
function make_editor()
{
    var bloc_text = document.getElementById("textarea1");
    if( bloc_text != null )
    {
        with( document.forms['send-form'] )
        {
            DOM_Event.addListener(elements['body_text'], "click", storeCaret, false);
            DOM_Event.addListener(elements['body_text'], "select", storeCaret, false);
            DOM_Event.addListener(elements['body_text'], "keyup", storeCaret, false);
            DOM_Event.addListener(elements['body_text'], "keydown", storeCaret, false);
        }
        
        make_button(bloc_text);
    }
    
    var bloc_html = document.getElementById("textarea2");
    if( bloc_html != null )
    {
        with( document.forms['send-form'] )
        {
            DOM_Event.addListener(elements['body_html'], "click", storeCaret, false);
            DOM_Event.addListener(elements['body_html'], "select", storeCaret, false);
            DOM_Event.addListener(elements['body_html'], "keyup", storeCaret, false);
            DOM_Event.addListener(elements['body_html'], "keydown", storeCaret, false);
        }
        
        make_button(bloc_html);
    }
}

function make_button(bloc)
{
    var format = bloc.id.substr((bloc.id.length - 1), 1);
    
    var conteneur = document.createElement("div");
    conteneur.setAttribute("class", "bottom");
    
    var bouton = document.createElement("input");
    bouton.setAttribute("id", "preview" + format);
    bouton.setAttribute("type", "button");
    bouton.setAttribute("value", lang["preview"]);
    bouton.setAttribute("class", "button");
    DOM_Event.addListener(bouton, "click", preview, false);
    conteneur.appendChild(bouton);
    conteneur.appendChild(document.createTextNode("\u00A0"));
    
    var bouton = document.createElement("input");
    bouton.setAttribute("id", "addLinks" + format);
    bouton.setAttribute("type", "button");
    bouton.setAttribute("value", lang["addlink"]);
    bouton.setAttribute("class", "button");
    DOM_Event.addListener(bouton, "click", addLinks, false);
    conteneur.appendChild(bouton);
    
    bloc.appendChild(conteneur);
}

/*
 * Fentre de prvisualisation des newsletters
 */
function preview(event)
{
    event = DOM_Event.normalize(event);
    
    var subject  = document.forms['send-form'].elements['subject'].value;
    var preview  = window.open('about:blank','apercu','width=' + width + ',height=' + height + ',marginleft=2,topmargin=2,left=' + left + ',top=' + top + ',toolbar=0,location=0,directories=0,status=0,scrollbars=1,resizable=0,copyhistory=0,menuBar=0');
    var rex_link = new RegExp("{LINKS}", "gi");
    
    if( event.target.id == 'preview1' )
    {
        var texte = document.forms['send-form'].elements['body_text'].value;
        texte = texte.replace(rex_link, "http://www.example.org");
        var boldSpan = new RegExp("(\\*\\w+\\*)", "g");
        var italicSpan = new RegExp("(/\\w+/)", "g");
        var underlineSpan = new RegExp("(_\\w+_)", "g");
        texte = texte.replace(boldSpan, "<strong>$1</strong>");
        texte = texte.replace(italicSpan, "<em>$1</em>");
        texte = texte.replace(underlineSpan, "<u>$1</u>");
        
        preview.document.writeln('<!DOCTYPE HTML PUBLIC "-\/\/W3C\/\/DTD HTML 4.01\/\/EN" "http:\/\/www.w3.org\/TR\/html4\/strict.dtd">');
        preview.document.writeln('<html><head><title>' + subject + '<\/title><\/head>');
        preview.document.writeln('<body><pre>' + texte + '<\/pre><\/body><\/html>');
    }
    else
    {
        var texte     = document.forms['send-form'].elements['body_html'].value;
        var rex_img   = new RegExp("<([^<]+)\"cid:([^\\:*/?<\">|]+)\"([^>]*)?>", "gi");
        var rex_title = new RegExp("<title>.*</title>", "i");
        var sessid    = '';
        
        for( var i = 0, m = document.forms.length; i < m; i++ )
        {
            if( document.forms[i].elements['sessid'] )
            {
                sessid = document.forms[i].elements['sessid'].value;
                break;
            }
        }
        
        texte = texte.replace(rex_link, '<a href="http://www.example.org/">Example</a>');
        texte = texte.replace(rex_img, "<$1\"../options/show.php?file=$2&amp;sessid=" + sessid + "\"$3>");
        texte = texte.replace(rex_title, '<title>' + subject + '</title>');
        
        preview.document.write(texte);
    }
    
    preview.focus();
}

function addLinks(event)
{
    event = DOM_Event.normalize(event);
    
    if( event.target.id == 'addLinks1' )
    {
        var texte = document.forms['send-form'].elements['body_text'];
    }
    else
    {
        var texte = document.forms['send-form'].elements['body_html'];
    }
    
    if( texte.createTextRange && texte.caretPos )
    {
        texte.caretPos.text = '{LINKS}';
    }
    else if ( texte.selectionStart > 0 )
    {
        var before = (texte.value).substring(0, texte.selectionStart);
        var after  = (texte.value).substring(texte.selectionStart, texte.textLength);
        texte.value = before + '{LINKS}' + after;
    }
    else
    {
        texte.value += '{LINKS}\n';
    }
    
    texte.focus();
}

function storeCaret(event) {
    event = DOM_Event.normalize(event);
    var textEl = event.target;
    
    if (textEl.createTextRange)
    {
        textEl.caretPos = document.selection.createRange().duplicate();
    }
}

if( support_dom() )
{
    var width  = (window.screen.width - 200);
    var height = (window.screen.height - 200);
    var top    = ((window.screen.height - height)/2);
    var left   = ((window.screen.width - width)/2);
    
    DOM_Event.addListener(window, "load", make_editor, false);
}

